=== debian/changelog ===
libreswan (5.0~rc2-2) experimental; urgency=medium

  * avoid build failure on 32-bit arches

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 14 Mar 2024 14:40:01 -0400

libreswan (5.0~rc2-1) experimental; urgency=medium

  * Import upstream release candidate into experimental
  * fix up patches, dropping several no longer needed
  * improve upstream orthography
  * d/copyright: track file renames
  * lintian-overrides: drop override for _secretcensor, no longer shipped
    upstream

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 11 Mar 2024 18:59:12 -0400
